﻿using System;
using System.Collections.Generic;
using System.Text;

namespace GridGrouping
{
    public class GroupingViewModel : Employee
    {
        private List<ProductInfo> productDetails;

        /// <summary>
        /// Initializes a new instance of the GroupingViewModel class.
        /// </summary>
        public GroupingViewModel()
        {
            ProductInfoRepository products = new ProductInfoRepository();
            this.ProductDetails = products.GetProductDetails(100);
        }

        /// <summary>
        /// Gets or sets the value of product details and notifies user when value gets changed
        /// </summary>
        /// <value>The product details.</value>
        public List<ProductInfo> ProductDetails
        {
            get
            {
                return this.productDetails;
            }

            set
            {
                this.productDetails = value;
                this.RaisePropertyChanged("ProductDetails");
            }
        }
    }
}
